/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 2.7.0, Date: 03-Feb-2022.
 * Copyright (c) 2003-2021 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include "csta3xml_Project.h"
#include "my_envelope.h"
#include "rtxsrc/rtxErrCodes.h"
#include "rtxmlsrc/rtXmlpCppDecFuncs.h"
#include "rtxsrc/rtxMemory.h"

int Header::decodeXML (OSCTXT* pctxt)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpCppGetXmlnsAttrs (pctxt, this);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode attributes */
   if (rtXmlpNeedDecodeAttributes (pctxt)) {
      size_t i, nAttrs = 0;

      stat = rtXmlpGetAttributeCount (pctxt);
      if (stat < 0) return LOG_RTERR (pctxt, stat);
      else nAttrs = (size_t)stat;
      stat = 0;

      for (i = 0; i < nAttrs; i++) {
         OSAnyAttrClass* pAnyAttr;
         const OSUTF8CHAR* ptm;
         OSXMLNameFragments attrName;
         OSINT16 nsidx;

         if (rtXmlpSelectAttribute (pctxt, &attrName, &nsidx, i) != 0) 
            continue;

         if (nsidx < -1) continue;

         pAnyAttr = new OSAnyAttrClass;
         if (pAnyAttr == 0)
            return LOG_RTERR (pctxt, RTERR_NOMEM);

         stat = rtXmlpDecDynUTF8Str (pctxt, &ptm);

         if (stat == 0) {
            pAnyAttr->setValue (attrName.mQName.value, ptm, 
               attrName.mQName.length);
            rtxMemFreePtr (pctxt, ptm);
            _anyAttr.append (pAnyAttr);
         }
         else {
            delete pAnyAttr;
            return LOG_RTERR (pctxt, stat);
         }
      }
      rtXmlpHideAttributes (pctxt);
   }

   { OSXMLElemDescr elemDescr;

   stat = rtXmlpGetNextElem (pctxt, &elemDescr, -1);
   if (stat < 0) return LOG_RTERR (pctxt, stat);
   else if(stat != XML_OK_EOB) {
      { const OSUTF8CHAR* ptm;
      /* decode xsd:any element as XML text */
      stat = rtXmlpDecAnyElem (pctxt, &ptm);
      _any.setValue (ptm);
      rtxMemFreePtr (pctxt, ptm);
      }
      if (stat != 0) return LOG_RTERR (pctxt, stat);

      stat = rtXmlpMatchEndTag (pctxt, -1);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }
   else return LOG_RTERR (pctxt, XML_E_ELEMSMISRQ);
   }

   return stat;
}

int Body::decodeXML (OSCTXT* pctxt)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpCppGetXmlnsAttrs (pctxt, this);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode attributes */
   if (rtXmlpNeedDecodeAttributes (pctxt)) {
      size_t i, nAttrs = 0;

      stat = rtXmlpGetAttributeCount (pctxt);
      if (stat < 0) return LOG_RTERR (pctxt, stat);
      else nAttrs = (size_t)stat;
      stat = 0;

      for (i = 0; i < nAttrs; i++) {
         OSAnyAttrClass* pAnyAttr;
         const OSUTF8CHAR* ptm;
         OSXMLNameFragments attrName;
         OSINT16 nsidx;

         if (rtXmlpSelectAttribute (pctxt, &attrName, &nsidx, i) != 0) 
            continue;

         if (nsidx < -1) continue;

         pAnyAttr = new OSAnyAttrClass;
         if (pAnyAttr == 0)
            return LOG_RTERR (pctxt, RTERR_NOMEM);

         stat = rtXmlpDecDynUTF8Str (pctxt, &ptm);

         if (stat == 0) {
            pAnyAttr->setValue (attrName.mQName.value, ptm, 
               attrName.mQName.length);
            rtxMemFreePtr (pctxt, ptm);
            _anyAttr.append (pAnyAttr);
         }
         else {
            delete pAnyAttr;
            return LOG_RTERR (pctxt, stat);
         }
      }
      rtXmlpHideAttributes (pctxt);
   }

   { OSXMLElemDescr elemDescr;

   stat = rtXmlpGetNextElem (pctxt, &elemDescr, -1);
   if (stat < 0) return LOG_RTERR (pctxt, stat);
   else if(stat != XML_OK_EOB) {
      { const OSUTF8CHAR* ptm;
      /* decode xsd:any element as XML text */
      stat = rtXmlpDecAnyElem (pctxt, &ptm);
      _any.setValue (ptm);
      rtxMemFreePtr (pctxt, ptm);
      }
      if (stat != 0) return LOG_RTERR (pctxt, stat);

      stat = rtXmlpMatchEndTag (pctxt, -1);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }
   else return LOG_RTERR (pctxt, XML_E_ELEMSMISRQ);
   }

   return stat;
}

int Envelope::decodeXML (OSCTXT* pctxt)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpCppGetXmlnsAttrs (pctxt, this);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode attributes */
   if (rtXmlpNeedDecodeAttributes (pctxt)) {
      size_t i, nAttrs = 0;

      stat = rtXmlpGetAttributeCount (pctxt);
      if (stat < 0) return LOG_RTERR (pctxt, stat);
      else nAttrs = (size_t)stat;
      stat = 0;

      for (i = 0; i < nAttrs; i++) {
         OSAnyAttrClass* pAnyAttr;
         const OSUTF8CHAR* ptm;
         OSXMLNameFragments attrName;
         OSINT16 nsidx;

         if (rtXmlpSelectAttribute (pctxt, &attrName, &nsidx, i) != 0) 
            continue;

         if (nsidx < -1) continue;

         pAnyAttr = new OSAnyAttrClass;
         if (pAnyAttr == 0)
            return LOG_RTERR (pctxt, RTERR_NOMEM);

         stat = rtXmlpDecDynUTF8Str (pctxt, &ptm);

         if (stat == 0) {
            pAnyAttr->setValue (attrName.mQName.value, ptm, 
               attrName.mQName.length);
            rtxMemFreePtr (pctxt, ptm);
            _anyAttr.append (pAnyAttr);
         }
         else {
            delete pAnyAttr;
            return LOG_RTERR (pctxt, stat);
         }
      }
      rtXmlpHideAttributes (pctxt);
   }

   { int elemID;

   static const OSXMLElemIDRec elemtab[] = {
      {{{OSUTF8("Header"), 6}, -6}, 0 },
      {{{OSUTF8("Body"), 4}, -6}, 1 }
   } ;

   static const OSXMLGroupDesc groupDesc[] = {
      { 0,  2, -1}, { 1,  1, -1}
    };

   int i;
   OSBOOL flBase = (OSBOOL) rtXmlpIsDecodeAsGroup (pctxt);

   stat = 0;
   for (i = 0; i < 2; i++) {
      OSBOOL flEndTag = TRUE;

      elemID = rtXmlpGetNextSeqElemID (pctxt, elemtab, groupDesc, i, 1, 
         flBase);
      if (elemID < 0) return LOG_RTERR (pctxt, elemID);
      else if (elemID == XML_OK_EOB) break;

      switch (elemID) {
      case 0: { /* Header */
         stat = Header.decodeXML (pctxt);
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         m.HeaderPresent = TRUE;
         break;
      }
      case 1: { /* Body */
         stat = Body.decodeXML (pctxt);
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         break;
      }
      }

      if (flEndTag) {
         stat = rtXmlpMatchEndTag (pctxt, -1);
         if (stat < 0) return LOG_RTERR (pctxt, stat);
      }

      i = elemID;
   }
   }

   return stat;
}

int detail::decodeXML (OSCTXT* pctxt)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpCppGetXmlnsAttrs (pctxt, this);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode attributes */
   if (rtXmlpNeedDecodeAttributes (pctxt)) {
      size_t i, nAttrs = 0;

      stat = rtXmlpGetAttributeCount (pctxt);
      if (stat < 0) return LOG_RTERR (pctxt, stat);
      else nAttrs = (size_t)stat;
      stat = 0;

      for (i = 0; i < nAttrs; i++) {
         OSAnyAttrClass* pAnyAttr;
         const OSUTF8CHAR* ptm;
         OSXMLNameFragments attrName;
         OSINT16 nsidx;

         if (rtXmlpSelectAttribute (pctxt, &attrName, &nsidx, i) != 0) 
            continue;

         if (nsidx < -1) continue;

         pAnyAttr = new OSAnyAttrClass;
         if (pAnyAttr == 0)
            return LOG_RTERR (pctxt, RTERR_NOMEM);

         stat = rtXmlpDecDynUTF8Str (pctxt, &ptm);

         if (stat == 0) {
            pAnyAttr->setValue (attrName.mQName.value, ptm, 
               attrName.mQName.length);
            rtxMemFreePtr (pctxt, ptm);
            _anyAttr.append (pAnyAttr);
         }
         else {
            delete pAnyAttr;
            return LOG_RTERR (pctxt, stat);
         }
      }
      rtXmlpHideAttributes (pctxt);
   }

   { OSXMLElemDescr elemDescr;

   stat = rtXmlpGetNextElem (pctxt, &elemDescr, -1);
   if (stat < 0) return LOG_RTERR (pctxt, stat);
   else if(stat != XML_OK_EOB) {
      { const OSUTF8CHAR* ptm;
      /* decode xsd:any element as XML text */
      stat = rtXmlpDecAnyElem (pctxt, &ptm);
      _any.setValue (ptm);
      rtxMemFreePtr (pctxt, ptm);
      }
      if (stat != 0) return LOG_RTERR (pctxt, stat);

      stat = rtXmlpMatchEndTag (pctxt, -1);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }
   else return LOG_RTERR (pctxt, XML_E_ELEMSMISRQ);
   }

   return stat;
}

int Fault::decodeXML (OSCTXT* pctxt)
{
   int stat = 0;

   /* decode xmlns attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpCppGetXmlnsAttrs (pctxt, this);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

   }

   /* decode xsi attributes */
   if (rtXmlpHasAttributes (pctxt)) {
      stat = rtXmlpDecXSIAttrs (pctxt);
      if (stat != 0) return LOG_RTERR (pctxt, stat);

      rtXmlpHideAttributes (pctxt);
   }

   { int elemID;

   static const OSXMLElemIDRec elemtab[] = {
      {{{OSUTF8("faultcode"), 9}, 0}, 0 },
      {{{OSUTF8("faultstring"), 11}, 0}, 1 },
      {{{OSUTF8("detail"), 6}, 0}, 2 }
   } ;

   static const OSXMLGroupDesc groupDesc[] = {
      { 0,  1, -1}, { 1,  1, -1}, { 2,  1, -1}
    };

   int i;
   OSBOOL flBase = (OSBOOL) rtXmlpIsDecodeAsGroup (pctxt);

   stat = 0;
   for (i = 0; i < 3; i++) {
      OSBOOL flEndTag = TRUE;

      elemID = rtXmlpGetNextSeqElemID (pctxt, elemtab, groupDesc, i, 1, 
         flBase);
      if (elemID < 0) return LOG_RTERR (pctxt, elemID);
      else if (elemID == XML_OK_EOB) break;

      switch (elemID) {
      case 0: { /* faultcode */
         rtXmlpSetWhiteSpaceMode (pctxt, OSXMLWSM_COLLAPSE);

         stat = rtXmlpCppDecXmlStr (pctxt, (OSRTXMLString*)&(faultcode));
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         break;
      }
      case 1: { /* faultstring */
         stat = rtXmlpCppDecXmlStr (pctxt, (OSRTXMLString*)&(faultstring));
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         break;
      }
      case 2: { /* detail */
         stat = detail.decodeXML (pctxt);
         if (stat != 0) return LOG_RTERR (pctxt, stat);

         m.detailPresent = TRUE;
         break;
      }
      }

      if (flEndTag) {
         stat = rtXmlpMatchEndTag (pctxt, -1);
         if (stat < 0) return LOG_RTERR (pctxt, stat);
      }

      i = elemID;
   }
   }

   return stat;
}

/**
 * Global element functions.  These functions encode or 
 * decode complete XML documents.  They are generated for global 
 * elements that are either:
 *
 * 1) not referenced by any other types, or
 * 2) explicitly declared to be a PDU using the -pdu command line
 *    option, or
 * 3) explicitly declared to be a PDU using the <isPDU/> 
 *    configuration file element.
 */

int Envelope_CC::decodeFrom (OSRTMessageBufferIF& msgbuf)
{
   int stat = 0;
   setMsgBuf (msgbuf);

   OSCTXT* pctxt = msgbuf.getCtxtPtr();
   if (0 == pctxt->pXMLInfo) {
      rtErrXmlInit ();
      stat = rtXmlInitCtxtAppInfo (pctxt);
      if (stat != 0) return (stat);
   }

   rtXmlpCreateReader (pctxt);

   rtXmlpSetNamespaceTable (pctxt, Get_csta3xml_NSURI(pctxt), 2);

   stat = rtXmlpMatchStartTag (pctxt, OSUTF8("Envelope"), -6);
   if (stat < 0) return LOG_RTERR (pctxt, stat);

   if (0 == mpValue) {
      mpValue = new Envelope();
      setOwnMemory();
   }

   stat = mpValue->decodeXML (pctxt);
   if (stat != 0) return LOG_RTERR (pctxt, stat);

   stat = rtXmlpMatchEndTag (pctxt, -1);
   if (stat < 0) return LOG_RTERR (pctxt, stat);

   return rtxErrGetStatus (pctxt);
}

